<?php

/************************************************* ****
 curl non-blocking calling class
 auther:linvo
 copyright (c) 2010/10/21
************************************************** ****/
/*
  //usage example
  //Incoming parameter description
  //url request address
  //data post data
  //Concurrent calls
  $param1=array (
        array (
            "url" =>"http://localhost/a.php?s=1",       
        ),      
        array (
            "url" =>"http://localhost/a.php?s=1",        
            "data" =>array ("aaa" =>1, "bbb" =>2),        
        ),      
    );
  //Single call
  $param2=array (
      "url" =>"http://localhost/a.php?s=0",      
      "data" =>array ("aaa" =>1, "bbb" =>2),      
    );
  //Single call (get simple way)
  $param3="http://localhost/a.php?s=2";
  $ac=new AsyncCurl ();
  $ac->set_param ($param1);
  $ret=$ac->send ();
  //The returned value is the result array of the request parameter order (element value is false to indicate a request error)
  var_dump ($ret);
*/
class AsyncCurl
{
  /**
   * Whether to return http header information
   */
  public $curlopt_header=0;
  
  /**
   * Single curl call timeout limit
   */
  public $curlopt_timeout=20;
  
  private $param=array ();

  /**
   * Constructor (can be directly passed in the request parameters)
   *
   * @param array optional
   * @return void
   */
  public function __construct ($param=false){
    if ($param !== false){
      $this->param=$this->init_param ($param);
    }
  }
  /**
   * Set request parameters
   *
   * @param array
   * @return void
   */
  public function set_param ($param){
    $this->param=$this->init_param ($param);
  }

  /**
   * send request
   *
   * @return array
   */
  public function send ()
  {
    if (!is_array($this->param) ||!count($this->param))
    {
      return false;
    }
    $curl=$ret=array ();
    $handle=curl_multi_init ();
    foreach ($this->param as $k =>$v){
        $param=$this->check_param($v);
        if (!$param) {
            $curl[$k] = false;
        }
        else{
            $curl[$k] = $this->add_handle($handle, $param);
        } 
    }

    $this->exec_handle($handle);
    foreach ($this->param as $k =>$v){
        if($curl [$k]){
            $ret [$k] = curl_multi_getcontent($curl [$k]);
            curl_multi_remove_handle($handle, $curl [$k]);
        } 
        else{
            $ret [$k]=false;
        }
    }
    curl_multi_close($handle);

    return $ret;
  }


    //The following are private methods
    private function init_param($param){
        $ret=false;
        if (isset($param ["url"])){
            $ret=array($param);
        } 
        else{
            $ret=isset($param [0])?$param:false;
        }
        return $ret;
    }



    private function check_param ($param=array()){
        $ret=array ();
        if (is_string ($param)){
            $url=$param;
        } 
        else{
            extract($param);
        }

        if(isset($url)){
            $url=trim ($url);
            $url=stripos($url, "http://")===0 ? $url : null;
        }

        if (isset($data) && is_array($data) && !empty($data)){
            $method="post";
        } 
        else{
            $method="get";
            unset($data);
        }

        if (isset($url)) $ret["url"] = $url;
        if (isset($method)) $ret["method"] = $method;
        if (isset($data)) $ret["data"] = $data;
        $ret=isset($url) ? $ret :false;

        return $ret;
    }


    private function add_handle ($handle, $param){
        $curl=curl_init ();
        curl_setopt ($curl, CURLOPT_URL, $param ["url"]);
        curl_setopt ($curl, CURLOPT_HEADER, $this->curlopt_header);
        curl_setopt ($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt ($curl, CURLOPT_TIMEOUT, $this->curlopt_timeout);
        
        if ($param ["method"] == "post"){
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $param ["data"]);
        }

        curl_multi_add_handle($handle, $curl);
        return $curl;
    }

    private function exec_handle ($handle){
        $flag=null;
        do {
            curl_multi_exec ($handle, $flag);
        } while($flag>0);
    }
}