<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/angular_material/1.1.8/angular-material.min.css">

<div id="id3-dlp-admin" 
    ng-app="id3Plugin" ng-controller="rootController" ng-init="rootInit()"
    >
    <div class="id3-page-header">
        <h1><i class="fal fa-hand-holding-box"></i> ID-3 Delivery Service</h1>
        <img src="<?php echo(PLUGIN_URL)?>assets/logos/ID3_color.png" />
    </div>

    <div class="id3-page-body" ng-cloak>
        <div class="search-box">
            <div class="search-box-content">
                <i class="fal fa-search"></i>
                <input type="text" ng-model="keywords" placeholder="Filter registrations">
            </div>
        </div>
        <div class="registration-list">
            <div class="list-header">
                <div>Site</div>

                <div>Filters</div>
                <div>Last sync</div>
                <div>Last update sent</div>
                <div></div>
            </div>
            <div ng-repeat="item in registrations | filter: keywords track by $index"
                    class="registration-item {{item.active ? 'active' : ''}} state-{{item.unreachable ? 'unreachable' : 'ok'}}">
                
                

                <div class="description">
                    <div><a href="https://{{item.id}}" target="_blank">{{item.id}}</a> <label class="pill warning" ng-if="!item.active">deactivated</label></div>
                    <em ng-if="item.error_message != null">{{item.error_message}}</em>
                </div>

                <span>{{item.filters.length}} filter(s)</span>

                <div>
                    <div ng-if="item.last_sync == null">Never</div>
                    <div ng-if="item.last_sync != null" am-time-ago="item.last_sync"></div>
                </div>

                <div>
                    <div ng-if="item.last_update_signal_sent == null">Never</div>
                    <div ng-if="item.last_update_signal_sent != null" am-time-ago="item.last_update_signal_sent"></div>
                </div>

                <div>
                    <md-menu>
                        <md-button class="md-icon-button" ng-click="$mdMenu.open()" title="More options"><i class="fal fa-ellipsis-v" ></i></md-button>
                        <md-menu-content>
                            <md-menu-item ng-if="item.active"><md-button ng-click="deactivateRegistration(item.id)"><i class="fal fa-ban" ></i> <span>Deactivate registration</span></md-button></md-menu-item>
                            <md-menu-item ng-if="!item.active"><md-button ng-click="activateRegistration(item.id)"><i class="fal fa-check" ></i> <span>Activate registration</span></md-button></md-menu-item>
                            <md-menu-item><md-button ng-click="deleteRegistration(item.id)"><i class="fal fa-times" ></i> <span>Delete registration</span></md-button></md-menu-item>
                        </md-menu-content>
                    </md-menu>
                    
                </div>
            </div>
        </div>
    </div>
</div>

<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular-animate.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular-aria.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular-route.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular-messages.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.9/angular-sanitize.min.js"></script>

<!-- Angular Material Library -->
<script src="https://ajax.googleapis.com/ajax/libs/angular_material/1.1.8/angular-material.min.js"></script>

<!-- Other Libraries -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment-with-locales.min.js" integrity="sha512-LGXaggshOkD/at6PFNcp2V2unf9LzFq6LE+sChH7ceMTDP0g2kn6Vxwgg7wkPP7AAtX+lmPqPdxB47A0Nz0cMQ==" crossorigin="anonymous"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/angular-moment/1.3.0/angular-moment.min.js"></script>

<script src="<?php echo(PLUGIN_URL)?>scripts/admin.min.js"></script>
<script type="text/javascript">

</script>


